using NUnit.Framework;
using System;
using System.Threading.Tasks;
using UserService.DatabaseLayer.Repositories;
using UserService.Infrastructure.DataModels;

namespace UserService.Test
{
    public class UserRepositoryTests
    {
        [Test]
        [Order(2)]
        public async Task Test1()
        {
            var usersRepository = new UsersRepository();
            var users = await usersRepository.GetAllAsync().ConfigureAwait(false);
            Assert.AreEqual(users.Count, 1);
        }

        [Test]
        [Order(1)]
        public async Task Test2()
        {
            var usersRepository = new UsersRepository();
            var user = new User
            {
                CommonName = "holger",
                FirstName = "Holger",
                LastName = "Brchers",
                IsActive = true
            };
            await usersRepository.AddAsync(user).ConfigureAwait(false);
        }

        [Test]
        [Order(3)]
        public async Task Test3()
        {
            var usersRepository = new UsersRepository();

            var user = await usersRepository.GetAsync(x => x.CommonName == "holger").ConfigureAwait(false);
            user.Description = DateTime.Now.ToString("O");
            await usersRepository.UpdateAsync(user).ConfigureAwait(false);
        }

        [Test]
        [Order(4)]
        public async Task Test4()
        {
            var usersRepository = new UsersRepository();

            var user = await usersRepository.GetAsync(x => x.CommonName == "holger").ConfigureAwait(false);
            await usersRepository.DeleteAsync(user).ConfigureAwait(false);
        }
    }
}